offset=20

while [ $# -gt 0 ]
do
    case $1 in
	'-o')
	    offset=$2
	    shift 2
	    continue
	    ;;
	*)
	    echo "usage: $argv[0] [-o offset]"
	    exit 1
	    ;;
  esac
done
echo "offset: $offset"

cd pgpool0
./startall
cd ..

#sleep 10 OK
#sleep 20 OK
#sleep 25 NG
#sleep 35 NG
#sleep 60 NG
#sleep 120 NG
#sleep 300 OK

echo -n "Sleep $offset seconds before starting pgpool1..."
sleep $offset
echo "done."

cd pgpool1
./startall
cd ..

echo "Wait for watchdogs become ready..."
for i in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
do
    echo -n "$i "
    pcp_watchdog_info -w -p 50001 -v|grep "QUORUM EXIST" > /dev/null
    if [ $? = 0 ];then
	break
    fi
    sleep 2
done
echo

echo "Shutdown data1."
date
pg_ctl -D pgpool0/data1 stop
date
timeout=600
echo "Expecting failover within $timeout seconds."
while [ $timeout -gt 0 ]
do
    grep -i "failover done." pgpool0/log/pgpool.log >/dev/null
    if [ $? = 0 ];then
	date
	echo "Failover done. Test succeeded."
	echo "Shutdown whole cluster."
	./shutdownall
	exit 0
    fi
    timeout=`expr $timeout - 10`
    sleep 10
    echo "Remaining $timeout seconds."
done

date
echo "Test failed".
echo "Shutdown whole cluster."
./shutdownall
exit 1

